<?php
namespace Digiwallet\Packages\Transaction\Client\InvoiceLine;

/**
 * Class InvoiceLine
 * @package Digiwallet\Packages\Transaction\Client\InvoiceLine
 */
class InvoiceLine implements InvoiceLineInterface
{
    const VAT_HIGH = 1;
    const VAT_LOW = 2;
    const VAT_NULL = 3;
    const VAT_NONE = 4;

    const VAT_TYPES = [
        self::VAT_HIGH,
        self::VAT_LOW,
        self::VAT_NULL,
        self::VAT_NONE
    ];

    /**
     * @var string
     */
    private $productCode;

    /**
     * @var string
     */
    private $productDescription;

    /**
     * @var int
     */
    private $quantity;

    /**
     * @var int
     */
    private $price;

    /**
     * @var int
     */
    private $taxCategory;

    /**
     * InvoiceLine constructor.
     * @param string $productCode
     * @param string $productDescription
     * @param int $quantity
     * @param int $price
     * @param string $taxCategory
     */
    public function __construct(
        $productCode,
        $productDescription,
        $quantity,
        $price,
        $taxCategory
    ) {
        $this->productCode = $productCode;
        $this->productDescription = $productDescription;
        $this->price = $price;
        $this->quantity = $quantity;
        $this->taxCategory = $taxCategory;
    }

    /**
     * @return string
     */
    public function productCode()
    {
        return $this->productCode;
    }

    /**
     * @return string
     */
    public function productDescription()
    {
        return $this->productDescription;
    }

    /**
     * @return int
     */
    public function quantity()
    {
        return $this->quantity;
    }

    /**
     * @return int
     */
    public function price()
    {
        return $this->price;
    }

    /**
     * @return int
     */
    public function taxCategory()
    {
        return $this->taxCategory;
    }

    /**
     * @return array
     */
    public function jsonSerialize()
    {
        return  [
            'productCode' => $this->productCode,
            'productDescription' => $this->productDescription,
            'quantity' => $this->quantity,
            'price' => $this->price,
            'taxCategory' => $this->taxCategory,
        ];
    }
}
