<?php
namespace Digiwallet\Packages\Transaction\Client\Request;

use Digiwallet\Packages\Transaction\Client\ClientInterface as TransactionClient;
use Digiwallet\Packages\Transaction\Client\Response\CheckTransactionInterface as CheckTransactionResponseInterface;
use Psr\Http\Message\RequestInterface;

/**
 * Interface TransactionRequest
 * @package Digiwallet\Packages\Transaction\Client\Request
 */
interface CheckTransactionInterface extends RequestInterface
{
    /**
     * @return CheckTransactionInterface
     */
    public function enableTestMode();

    /**
     * @param int $outletId
     * @return CheckTransactionInterface
     */
    public function withOutlet($outletId);

    /**
     * @param string $bearer
     * @return CheckTransactionInterface
     */
    public function withBearer($bearer);

    /**
     * @param int $transactionId
     * @return CheckTransactionInterface
     */
    public function withTransactionId($transactionId);

    /**
     * @return CheckTransactionResponseInterface
     */
    public function send();
}
