<?php

namespace Digiwallet\Packages\Transaction\Client\Response;

/**
 * Interface TransactionResponse
 * @package Digiwallet\Packages\Transaction\Client\Response
 */
interface CheckTransactionInterface
{
    /**
     * @return int
     */
    public function getStatus();

    /**
     * @return string
     */
    public function getTransactionStatus();

    /**
     * @return string
     */
    public function getMessage();

    /**
     * @return int
     */
    public function getExternalTransactionID();

    /**
     * @return int
     *
     * the amount paid in cents
     */
    public function getPaidAmount();

    /**
     * @return string
     */
    public function getExternalPaymentReference();

    /**
     * @return string|null
     */
    public function consumerName();

    /**
     * @return string|null
     */
    public function consumerIBAN();

    /**
     * @return string|null
     */
    public function consumerCountryCode();

    /**
     * @return string|null
     */
    public function consumerCardNumberMasked();

    /**
     * @return string|null
     */
    public function consumerCardExpiryDate();

    /**
     * @return string|null
     */
    public function consumerCardBrand();

    /**
     * @return string(3)|null
     */
    public function getPaymentMethodCode();
}
